/*
 * e4-text.c
 * Copyright (C) 2006-2014, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <string.h>

#include <e4-defs.h>
#include <e4-types.h>

#define I_MODE(i)			(*((C_MODE *) (i)))
#define I_TEXT(t)			(*((C_TEXT *) (t)))

#define l_MODE(e, output) \
    {									      \
	C_MODE *l;							      \
									      \
	l = (output);							      \
	*l = (e);							      \
    }

int
_x1f4_e4_text_this(x1f4_e4_LINK_ARGS_1)
{
    C_MODE miss, this;
    C_TEXT text;

    text = I_TEXT(input[0]);

    this = I_MODE(input[1]);
    if (this < 0) {
	this += strlen(text);
	if (this < 0) {
	    miss = 0;
	} else {
	    miss = ((unsigned char *) text)[this];
	}
    } else {
	while (1) {
	    int c;

	    c = *(unsigned char *) text;
	    if (c) {
		if (this) {
		    text++;
		    this--;
		} else {
		    miss = c;
		    break;
		}
	    } else {
		miss = 0;
		break;
	    }
	}
    }

    l_MODE(miss, output);

    return 0;
}
