/*
 * lxlist-m.p.0.c
 * Copyright (C) 2008-2011, 2013-2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <e4.h>
#include <lxlist-drive.h>
#include <lxlist-inter.h>
#include <lxlist-types.h>

#define I_LIST(t)			(*((X1f4_E4_C_USER *) (t)))
#define I_MODE(t)			(*((X1f4_E4_C_MODE *) (t)))

#define l_MODE(e, output) \
    {									      \
	X1f4_E4_C_MODE *l;						      \
									      \
	l = (void *) (output);						      \
	*l = (e);							      \
    }

int
_libx1f4i0_lxlist_p0class_m(void *context, void *output, void **input)
{
    int status;
    struct cxbend_type *cxbend_data;
    struct dxlist_type *dxlist_data;

    cxbend_data = context;

    dxlist_data = I_LIST(input[0]);

    if (1) {
	void *data;

	status = cxbend_data->push(dxlist_data->list, &data);
	if (status) {
	    status = _libx1f4i0_lxlist_stat_list(cxbend_data->list, 0, status);
	} else {
#define type				X1f4_E4_MODE

	    type_effect(data, type);

	    link_effect(data, ~0);

	    dxlist_data->size++;

	    l_MODE(I_MODE(input[1]), byte(data) + 8);

#undef type
	}
    }

    return status;
}
