/*
 * lxxsxx-2.s.c
 * Copyright (C) 2008-2011, 2013, 2014, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <lxport-inter.h>
#include <lxport-types.h>

#define I_PORT(t)			(*((X1f4_E4_C_USER *) (t)))

int
_libx1f4i0_lxport_s_2xshell(void *context, void *output, void **input)
{
    int status;
    struct waitlink_type *waitlink_data;
    struct xsport_type *xsport_data;

    xsport_data = I_PORT(input[0]);

    waitlink_data = xsport_data->waitlink_data;

    if (waitlink_data->port ^ -1) {
	status = _libx1f4i0_lxport_pend_port(context, waitlink_data);
    } else {
	status = 0;
    }

    return status;
}
