/*
 * lxline-k.h.c
 * Copyright (C) 2008-2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <lxline-config.h>

#include <e4.h>
#include <l_note.h>
#include <lxcall.h>
#include <lxline-drive.h>
#include <lxline-inter.h>
#include <lxline-types.h>

#define I_LINE(t)			(*((X1f4_E4_C_USER *) (t)))

#define l_MODE(e, output) \
    {									      \
	X1f4_E4_C_MODE *l;						      \
									      \
	l = (output);							      \
	*l = (e);							      \
    }

int
_libx1f4i0_lxline_h_keeping(void *context, void *output, void **input)
{
    int status;
    struct cxbend_type *cxbend_data;
    struct dxline_type *dxline_data;
    struct lxline_type *lxline_data;

    dxline_data = I_LINE(input[0]);

    cxbend_data = context;

    lxline_data = cxbend_data->line;

    if (0) {
    } else {
	const char *lift;
	unsigned size;
	void *data;

	status = cxbend_data->gate(dxline_data->line, &data, &lift, &size);
	if (status) {
	    if (status ^ X1f4_SFNOTE_DECK_ERROR) {
		status = _libx1f4i0_lxline_stat_line(lxline_data, 0, status);
	    } else {
		l_MODE(0, output);
		if (1) {
		    status = 0;
		}
	    }
	} else {
	    status = _libx1f4i0_lxcall_swap_text
		(&lxline_data->ever_a, input[1], (void *) lift, size + 1);
	    if (0) {
	    } else {
		l_MODE(1, output);
	    }
	}
    }

    return status;
}
