/*
 * lxnext-e.6.c
 * Copyright (C) 2008-2011, 2013-2015, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <lxcall.h>
#include <lxlock.h>
#include <nl.h>

int
_libx1f4i0_lxnext_push_text(void *lxlock, void **copy, void *text,
			    const struct x1f4_nodelink_type *nodelink_data)
{
    int status;

    status = _libx1f4i0_lxcall_pick_text(lxlock, copy);
    if (status) {
    } else {
	*copy = text;
    }

    return status;
}
