/*
 * lxrail-e.v.c
 * Copyright (C) 2014-2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <lxrail-types.h>
#include <mxdeck.h>

int
_libx1f4i0_lxrail_link_past(struct x1f4_linetrap_type *linetrap_data,
			    struct depart_type *depart_data,
			    const char *fx_pickf, unsigned fx_pickf_size,
			    const char *fx_queryf, unsigned fx_queryf_size)
{
    depart_data->ftaa_qlaw->linetext_data = NULL;
    depart_data->ftaa_qlaw->type = X1f4_E4_VOID;
    depart_data->ftaa_xlaw->linetext_data = NULL;
    depart_data->ftaa_xlaw->type = X1f4_E4_VOID;
    depart_data->ftca_qlaw->linetext_data = NULL;
    depart_data->ftca_qlaw->type = X1f4_E4_VOID;
    depart_data->ftca_xlaw->linetext_data = NULL;
    depart_data->ftca_xlaw->type = X1f4_E4_VOID;

    x1f4_post_mxpath
	(linetrap_data->fpaccess, fx_queryf, fx_queryf_size,
	 depart_data->fpdetail_qlaw);
    x1f4_post_mxpath
	(linetrap_data->fpaccess, fx_pickf, fx_pickf_size,
	 depart_data->fpdetail_xlaw);

    return 0;
}
